#!/usr/bin/tclsh8.5

# command line for testing:   ./main.tcl -s Yamal_JAH_raw.txt -m TR-Raw-Measurement-Template.tmp


if {$argc < 6 || $argc > 6} {
	puts "Usage: -s \[source file\] -m \[template file\] -d \[data file\]" 
	
} else {

	set TreeRing_file_RW [string trim [lindex $argv 1] " "]
	set template [string trim [lindex $argv 3] " "]
	set TreeRing_file [string trim [lindex $argv 5] " "]
	
	source tree-ring-raw-file-parser.tcl

	tree-ring-raw-file-parser::addSite "67.45 -70.79" NULL "Russia" "station" "YAMALAD"

	set paramList [tree-ring-raw-file-parser::parseTreeRing $TreeRing_file_RW $template "YAMALAD"]
	puts $paramList

	source tree-ring-results-file-parser.tcl

	tree-ring-results-file-parser::parseTreeRing "YAMALAD." $TreeRing_file $template $paramList
	
}


