#!/usr/bin/tclsh8.5



# Register the package
package provide tree-ring-results-file-parser 1.0
package require Tcl                 8.4

# Create the namespace
namespace eval ::tree-ring-results-file-parser {
	# Export commands
	namespace export parseTreeRing
}


proc ::addObs {origin_id start_year end_year template runtimeParams paramlist} {

	set db [pg_connect -conninfo [list host = "tiger.dl.ac.uk" user = "remote-user" password = "Counter1" dbname = "acrid_tree_ring"]]

	puts "checking for existing $origin_id record"
	
	

	set result [pg_exec $db "SELECT version_id FROM observations where origin_id = '$origin_id' order by creation_date DESC limit 1"]
	set row [pg_result $result -llist]
	set ver_id 1
	
	if {[llength $row] > 0 } then  {
		set ver_id [expr {[lindex $row 0] + 1}]
		puts $ver_id
	}
	set title "'$origin_id'"

	set xml "<test>value</test>"

        puts "adding CRUTEM3 observation with origin id: $origin_id and version: $ver_id ..."
	
	set result [pg_exec $db "INSERT INTO observations values ('$ver_id','$origin_id', $title, 'http://tridas.org/documents/xmldocs/1.2.2/tridas-1.2.20.html#id199', $start_year, $end_year, now(), 3, XMLPARSE (DOCUMENT '$xml'),2, 'GridSeries', NULL) "]
	if {[pg_result $result -status] != "PGRES_COMMAND_OK"} {
        	puts "[pg_result $result -error]"
	    	pg_result $result -clear
		
        } else {
		pg_result $result -clear
		pg_exec $db "INSERT INTO obs_params (ob_origin_id, ob_version_id, name, other_value, other_value_uom) values ('$origin_id','$ver_id', 'http://www.cru.uea.ac.uk/cru/projects/acrid/ontologies/tree-ring/softwareOptionsUsed', '$runtimeParams', NULL)"
		foreach item $paramlist {
		
			if {$item != -1} {
			
				pg_exec $db "INSERT INTO obs_params (ob_origin_id, ob_version_id, name, obs_value_origin, obs_value_version) values ('$origin_id','$ver_id', 'Raw-tree-core-measurements', $item)"
		
			}
		}
	}
	pg_disconnect $db
}

proc ::tree-ring-results-file-parser::parseTreeRing {siteID nfile template paramlist} {
	#open the file
	set infile [open $nfile r]

	set outfile [open testout.dat "w"]
	set linePrev " miss"
	set startYear 0
	set endYear 0
	while { [gets $infile line] >= 0 } {
		
		#puts $line
		#puts [string index $line 25]

		if {[string index $line 0] == " "} {
			set foundHeader1 1	
			set foundHeader2 1
			
			set runID $line
			set runID [string trimleft $runID]
			gets $infile line
			set params $line
			gets $infile line
			append params "," $line
			puts $runID
			puts $params
			puts $startYear
			puts $endYear
			if {[string first $siteID $runID] == 0} {
				addObs $runID $startYear $endYear $template $params $paramlist
			}
			
		}
		
		if {$foundHeader1 && [string index $line 0] != " "} {
			set foundHeader1 0
			set foundHeader2 0
			set temp [string range $line 6 end-75]
			set temp [string trimleft $temp]
			set startYear $temp
		}

		if {$foundHeader2 && [string index $linePrev 0] != " "} {
			
			set endYearDec [string range $linePrev 6 end-75]
			set pos1 10
			set pos2 71
			set count 0
			for { set i 1 } { $i <= 10 } { incr i } {

				if {[string range $linePrev $pos1 end-$pos2] == "9990"} {
					incr count
				}
				incr pos1 7
				incr pos2 -7

			}
			set endYear [expr $endYearDec + 9 - $count]
		}

		set linePrev $line

		
	}


}
